# -*- coding: utf-8 -*-
"""

Copyright or © or Copr:
    Antoine Falaize

Affiliation:
    Team M2N (Mathematical and Numerical Methods),
    Laboratoire des Sciences de l'Ingénieur pour l'Environnement (LaSIE),
    UMR CNRS 7356, La Rochelle Université,
    La Rochelle, France.

Contact:
    antoine.falaize@univ-lr.fr

This file has been generated by the Python software PyPHS, which purpose
is to model and simulate multiphysical systems in the Port-Hamiltonian
formalism.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A copy of the GNU General Public License is available at the following url:
"https://www.gnu.org/licenses/"

"""

# Python 2 back-portability
from __future__ import absolute_import

# PyPI setup tools
from setuptools import setup, find_packages

# To use a consistent encoding
from codecs import open

# Os specific methods to manage paths
from os import path

# Recover metadata from pyphs.__init__.py
from pyphs import __author__, __version__, __license__, __author_email__

# ----------------------------------------------------------------------
# Recover README from source
here = path.abspath(path.dirname(__file__))

with open(path.join(here, 'README.rst'),
          encoding='utf-8') as f:
    long_description = f.read()

# ----------------------------------------------------------------------
# Define PyPI setup configuration

setup(name='pyphs',
      version=__version__,
      description="Development Status :: 4 - Beta",
      long_description=long_description,
      classifiers=[
        'Natural Language :: English',
        'Development Status :: 4 - Beta',
        'Operating System :: Unix',
        'Operating System :: MacOS',
        'Operating System :: MacOS :: MacOS X',
        'Operating System :: Microsoft',
        'Operating System :: Microsoft :: Windows',
        'Programming Language :: Python :: 2',
        'Programming Language :: Python :: 2.7',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.5',
        'Programming Language :: Python :: 3.6',
        'Intended Audience :: Science/Research',
        'License :: OSI Approved :: ' + __license__,
        'Topic :: Scientific/Engineering',
        'Topic :: Scientific/Engineering :: Physics'
      ],
      keywords='dynamical systems, numerical analysis, \
      passive systems, port-hamiltonian systems, C++, Latex',
      url='https://github.com/pyphs/pyphs',
      author=__author__,
      author_email=__author_email__,
      license=__license__,
      packages=find_packages(exclude=['docs', ]),
      zip_safe=False,
      include_package_data=True,
      install_requires=[
            'numpy>=1.15',
            'scipy>=0.16',
            'sympy>=1.2',
            'networkx>=2.2',
            'progressbar2>=3.30',
            'matplotlib>=2.1',
            'h5py>=2.7'],
      test_suite='nose.collector',
      tests_require=['nose'],
      )
